%% PLSR is used to establish the estimation model for LNC estimation
%% For each training, the dataset is randomly divided into the training and testing datasets
%% We run the model 10 times, and the averaged model accuracy indicates the final result
%--------------------------------------------------------------------------
clear;clc;close all
for x=1:10 %run the code 10 times
data1=xlsread('xx.xlsx','xx'); %input of leaf nitrogen
R= xlsread('xx.xlsx','xx');%input of leaf relfectance
%% dividing the traning and testing dataset
[mm,nn]=size(data1);
ids=datasample(1:mm,round(mm*2/3),'Replace',false); % random sampling
X=R(ids,:); Y=data1(ids); numY=length(Y); % training dataset
idsTest=1:mm; idsTest(ids)=[];
Xtest=R(idsTest,:); Ytest=data1(idsTest); numYTest=length(Ytest);% testing dataset
CV=plscv(X,Y,100,10);  %N=10 indicates 10-fold cross validationwhen N=m(samples) leave-one-out cross validation 
%by default, 'center' is used for data pretreatment inside plscv.m.  
% plot(CV.RMSECV,'bo-','linewidth',2);
% xlabel('number of latent variables');
% ylabel('RMSECV');
% set(gcf,'color','w');
%RMSECV
PLS=pls(X,Y,CV.optLV,'center');  %+++ Build a PLS model with 10 components, pretreat method is 'center'.
[ypred,~]=plsval(PLS,Xtest,Ytest); %+++ make predictions on test set
cct=corrcoef(Ytest,ypred);
cct=cct(2,1);
R2=cct^2;Et=Ytest-ypred;kk=size(Ytest,1);RMSEP=sqrt(sum((Et).^2)/numYTest);RRMSE=RMSEP/mean(Ytest,1);
A(x,1)=R2;A(x,1)=RMSEP;A(x,1)=RRMSE;% model results
end
